import behavior from "utils/behavior";
const CLICK = "click";
const PREFIX = "usa";

const LINK = `.${PREFIX}-skipnav[href^="#"], .${PREFIX}-footer__return-to-top [href^="#"]`;
const MAINCONTENT = "main-content";

function setTabindex() {
  // NB: we know because of the selector we're delegating to below that the
  // href already begins with '#'
  const id = encodeURI(this.getAttribute("href"));
  const target = document.getElementById(
    id === "#" ? MAINCONTENT : id.slice(1),
  );

  if (target) {
    target.style.outline = "0";
    target.setAttribute("tabindex", 0);
    target.focus();
    target.addEventListener("blur", () => target.setAttribute("tabindex", -1), {
      once: true,
    });
  } else {
    // throw an error?
  }
}

const skipnav = behavior({
  [CLICK]: {
    [LINK]: setTabindex,
  },
});
export default skipnav;
window.uswdsComponents = window.uswdsComponents || [];
window.uswdsComponents.push(skipnav);
