<?php

namespace Drupal\uswds_storybook\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Attribute\FieldWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\Plugin\Field\FieldWidget\OptionsSelectWidget;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Provides a combo box field widget.
 */
#[FieldWidget(
  id: 'combobox',
  label: new TranslatableMarkup('Combo box'),
  field_types: [
    'entity_reference',
    'list_string',
    'dynamic_entity_reference',
  ],
  multiple_values: FALSE,
)]
class ComboBox extends OptionsSelectWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);
    $element['#type'] = 'combobox';
    $element['#multiple'] = FALSE;
    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function supportsGroups() {
    return FALSE;
  }

}
