<?php

namespace Drupal\uswds_storybook\Plugin\Field\FieldWidget;

use Drupal\Core\Field\Attribute\FieldWidget;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\StringTranslation\TranslatableMarkup;
use Drupal\datetime\Plugin\Field\FieldWidget\DateTimeDefaultWidget;

/**
 * Exposes the memorable_date form element as a field widget.
 */
#[FieldWidget(
  id: "memorable_date",
  label: new TranslatableMarkup('Memorable date'),
  field_types: ['datetime'],
)]
class MemorableDate extends DateTimeDefaultWidget {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);
    if ($element['value']['#date_date_element'] == 'date') {
      $element['value']['#date_date_element'] = 'memorable_date';
    }
    return $element;
  }

}
